/*
 *    Copyright 2018-2019 adview.com, Inc.
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
package com.adview.mobile.adviewkotlindemo.activities.ads.admob

import android.os.Bundle
import android.util.Log
import com.google.android.gms.ads.AdRequest
import com.google.android.gms.ads.LoadAdError
import com.google.android.gms.ads.interstitial.InterstitialAd
import com.google.android.gms.ads.interstitial.InterstitialAdLoadCallback
import com.adview.sdk.admob.AdMobMediationInterstitialUtils
import com.adview.sdk.admob.AdviewInterstitialAdapter
import com.adview.sdk.api.data.AdUnitFormat
import com.adview.sdk.api.mediation.MediationInterstitialAdUnit
import com.adview.mobile.adviewkotlindemo.activities.BaseAdActivity
import java.util.*

class AdMobVideoInterstitialActivity : BaseAdActivity() {

    companion object {
        const val AD_UNIT_ID = "ca-app-pub-7283949697136772/5248357557"
        const val CONFIG_ID = "POSIDwog9g88wqy1g" //official line for video
    }

    private var adUnit: MediationInterstitialAdUnit? = null
    private var interstitialAd: InterstitialAd? = null


    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        createAd()
    }

    private fun createAd() {
        val extras = Bundle()
        val request = AdRequest
            .Builder()
            .addNetworkExtrasBundle(AdviewInterstitialAdapter::class.java, extras)
            .build()
        val mediationUtils = AdMobMediationInterstitialUtils(extras)
        adUnit = MediationInterstitialAdUnit(
            this,
            CONFIG_ID,
            EnumSet.of(AdUnitFormat.VIDEO),
            mediationUtils
        )

        adUnit?.fetchDemand { result ->
            Log.d("Adview", "Fetch demand result: $result")

            InterstitialAd.load(this, AD_UNIT_ID, request, object : InterstitialAdLoadCallback() {
                override fun onAdLoaded(interstitial: InterstitialAd) {
                    interstitialAd = interstitial
                    val mediationAdapter = interstitial.responseInfo.mediationAdapterClassName
                        interstitialAd?.show(this@AdMobVideoInterstitialActivity)
                }

                override fun onAdFailedToLoad(error: LoadAdError) {
                    interstitialAd = null
                }
            })
        }
    }


    override fun onDestroy() {
        super.onDestroy()
        adUnit?.destroy()
    }

}
